--#include "ksrc/kstrings.lua"
--#include "ksrc/kargs.lua"
--#include "ksrc/kio.lua"
--#include "ksrc/vfs.lua"
--#include "ksrc/struct.lua"
--#include "ksrc/string.lua"
--#include "ksrc/archives.lua"
--#include "ksrc/ads.lua"
--#include "ksrc/blkdev.lua"
--#include "ksrc/acl.lua"
--#include "ksrc/security.lua"
--#include "ksrc/exec.lua"
--#include "ksrc/fs/foxfs/init.lua"
--#include "ksrc/tty.lua"
--#include "ksrc/biosfixes.lua"
--#include "ksrc/buffer.lua"
--#include "ksrc/threads.lua"
--#include "ksrc/net.lua"

kio.dmesg(1, "Starting Tsuki kernel.")
kio.init()

-- Mount the initramfs, if there is one.
if (kargs.iramfs or kargs.root == "$") then
	vfs.mount("/", arcfs.proxy(_ARCHIVE))
end

-- Eventually...
do
	local pty = tty.get(0)
	kio.dmesg(1, "Passing off to init.")
	exec.startfile(kargs.init or "/bin/init.velx", true, {
		uid = 0,
		gid = 0,
		tty = pty,
		args = {kargs}
	})
end